unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ActnList;
var
 id : integer;
type

  { TMishan }

  TMishan = class
    x, y       : integer;{Координати мишени}
    direction1  : integer;
    imagesMishan : TImageList;
    procedure Draw(var Image:TImage);{Малювати}

    function  Popal(kx,ky: Integer):boolean; { Перевірка "чи попав" }
    procedure Init;                   {Встановити початкові дані}
  end;



  { TSnaryad }

  TSnaryad = class
    x, y       : integer;     {Координати танку}
    speed      : integer;     {Швидкість танку в пікселях за крок}
    direction  : integer;     {Напрям танку 0-вгору; 1-праворуч; 2-вниз; 3-ліоруч }
    enabled    : boolean;     { Чи задіяний снаряд }

    procedure Step;                   {Поміняти координати}
    procedure Draw(var Image:TImage); {Малювати}
    procedure Init;                   {Встановити початкові дані}

  end;

  { TTank }

  TTank = class
    x, y       : integer;     {Координати танку}
    speed      : integer;     {Швидкість танку в пікселях за крок}
    direction  : integer;     {Напрям танку 0-вгору; 1-праворуч; 2-вниз; 3-ліоруч }
    imagesTank : TImageList;  {Посилання на список малюнків для танку}
    runing     : boolean;     {Чи рухаеться танк true-false }

    procedure Stop;                   {Не робити ні чого}
    procedure Step;                   {Поміняти координати}
    procedure Draw(var Image:TImage); {Малювати}
    procedure Init;                   {Встановити початкові дані}
  end;


  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    ImageList1: TImageList;
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    myTank    : TTank;
    mySnaryad : TSnaryad;
    myMishan  : TMishan;

    { Масив зі станом кнопок
      0 - кнопка вгору       1
      1 - кнопка праворуч    1
      2 - кнопка вниз        1
      3 - кнопка лівовуч     1
      4 - "огонь" (проміжок) 1

    }
    bottons   : array [0..15] of boolean;
  end; 

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TMishan }
procedure TMishan.Draw(var Image:TImage); {Малювати}
var i: integer;
begin
  imagesMishan.Draw(Image.Canvas, x, y, direction1);
    for i:=4 downto 1 do
  begin
  imagesMishan.Draw(Image.Canvas,x,y, direction1);
  end;
end;

function  TMishan.Popal(kx,ky: Integer):boolean; { Перевірка "чи попав" }
var d : double;
 s : double;
 id : integer;
begin
   s := 0;
   id := 0;
  d := sqr(x-kx)+sqr(y-ky);
  if d < 64 then
  begin
    Init;
    Popal := true;
    id:= id+1;
    Tform1.Label1.Caption:=IntToStr(id);

  end else
  begin
    Popal := false;
  end;
end;

procedure TMishan.Init;                   {Встановити початкові дані}
begin
  x := random(450)+25;
  y := random(450)+25;
  direction1 := 4;
end;


{ TSnaryad }
procedure TSnaryad.Step;                   {Поміняти координати}
begin
  if enabled then
  begin

   case direction of
    0: begin
         if y>=speed then y := y - speed else enabled:=false;
       end;
    1: begin
         if x<=(512-speed) then x := x + speed else enabled:=false;
       end;
    2: begin
         if y<=(512-speed) then y := y + speed else enabled:=false;
       end;
    3: begin
         if x>=speed then x := x - speed else enabled:=false;
       end;
   end;

  end;
end;

procedure TSnaryad.Draw(var Image:TImage); {Малювати}
begin
  if enabled then
  begin
    Image.Canvas.Brush.Color := clRed;
    Image.Canvas.Pen.Color   := clGreen;
    Image.Canvas.RoundRect(x-4,y-4,x+4,y+4,3,3);
  end;
end;

procedure TSnaryad.Init;                   {Встановити початкові дані}
begin
  x:=0;
  y:=0;
  speed := 10;
  direction := 0;
end;

{ TTank }
procedure TTank.Stop;                   {Не робити ні чого}
begin

end;

procedure TTank.Step;                   {Поміняти координати}
begin
 if runing then
 begin
  case direction of
    0: begin
         if y>=speed then y := y - speed;
       end;
    1: begin
         if x<=(512-32-speed) then x := x + speed;
       end;
    2: begin
         if y<=(512-32-speed) then y := y + speed;
       end;
    3: begin
         if x>=speed then x := x - speed;
       end;
  end;
 end;
end;

procedure TTank.Draw(var Image:TImage); {Малювати}
begin
  imagesTank.Draw(Image.Canvas, x, y, direction);
end;

procedure TTank.Init;                   {Встановити початкові дані}
begin
  x := 128;
  y := 128;
  speed := 3;
  direction := 2;
  runing := false;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.Line(0,0,511,511);
  myTank := TTank.Create;
  myTank.Init;
  myTank.imagesTank := ImageList1;
  myTank.Draw(Image1);


  mySnaryad := TSnaryad.Create;
  mySnaryad.Init;

  myMishan := TMishan.Create;
  myMishan.Init;
  myMishan.imagesMishan := ImageList1;
  myMishan.Draw(Image1);

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin

  Form1.Caption := IntToStr( Key );
  if (Key>=37)and(Key<=40) then myTank.runing:=true;
  case Key of
    27: Form1.Close;
    37: myTank.direction:=3;
    38: myTank.direction:=0;
    39: myTank.direction:=1;
    40: myTank.direction:=2;

    32:
    if not mySnaryad.enabled then
    begin
         { Тут запускаємо снаряд }
         mySnaryad.x := myTank.x + 16;
         mySnaryad.y := myTank.y + 16;
         mySnaryad.enabled := true;
         mySnaryad.direction := myTank.direction;
         mySnaryad.Step;
    end;
  end;

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key>=37)and(Key<=40) then myTank.runing:=false;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  { Очистити поле }
  Image1.Canvas.Brush.Color:=clBlack;
  Image1.Canvas.FillRect(0,0,512,512);
  { Робимо дії для ігрових одиниць }
  myTank.Step;
  mySnaryad.Step;
  if myMishan.Popal(mySnaryad.x,mySnaryad.y) then
  begin
    mySnaryad.enabled:=false;
  end;
  { Малюємо ці одиниці }
  myMishan.Draw(Image1);
  mySnaryad.Draw(Image1);
  myTank.Draw(Image1);

end;

end.

